<?php

class Signup extends CI_Controller {


    function __construct() {
        parent::__construct();
        error_reporting(E_ALL ^ (E_NOTICE | E_WARNING));
         $this->load->model('signup_model');
         $this->load->model('Utilities_model');
         $this->load->model('login_model');


    }

    function index(){
        $this->showSignupForm();
    }

    /**
     * Just fetches the signup_form_view VIEW for us.
     *
     * @author Amit Shrivastava
     * @package Vlab
     *
     *      */
    function showSignupForm() {
        $data['data']=NULL;
        $data['main_content'] = 'signup_view';
        $this->load->view('includes/template', $data);
    }

    function offer() {
   
        $data['main_content'] = 'offer_signup_view';
        $this->load->view('includes/template', $data);
    }

  function checkOffer() {
  
       $this->form_validation->set_rules('spname', 'Service Provider Name', 'trim|required|min_length[2]|max_length[25]|xss_clean');
       $this->form_validation->set_rules('name', 'Name', 'trim|required|min_length[2]|max_length[25]|xss_clean');
       $this->form_validation->set_rules('email', 'Email Address', 'trim|required|valid_email|xss_clean');
       $this->form_validation->set_rules('mobile', 'Mobile Number', 'trim|min_length[10]|max_length[10]|required|numeric|xss_clean');
       $this->form_validation->set_rules('password', 'Password', 'trim|required|xss_clean|min_length[5]|max_length[32]|matches[passconf]|');
       $this->form_validation->set_rules('passconf', 'Password Confirmation', 'trim|required|');
       $this->form_validation->set_rules('city', 'City', 'trim|required|xss_clean');
       $this->form_validation->set_rules('state', 'State', 'trim|required|xss_clean');
       $this->form_validation->set_rules('country', 'Country', 'trim|required|xss_clean');
       $this->form_validation->set_rules('pincode', 'Pincode', 'trim|min_length[6]|max_length[6]|required|numeric|xss_clean');

        //Run the validation rules and if false, show error messages on the view itself

        if($this->form_validation->run() == FALSE) {

        $this->offer();
        }
        else{
        //Assign Posted Values to variables

            $name = $this->input->post('name');
            $spname = $this->input->post('spname');
            $off_address = $this->input->post('off_address');
            $area = $this->input->post('area');
            $type = $this->input->post('type');
            $landmark = $this->input->post('landmark');
            $city = $this->input->post('city');
            $state = $this->input->post('state');
            $pincode = $this->input->post('pincode');
            $country = $this->input->post('country');

/*            foreach($this->input->post('service_type') as $key =>$val){
                        $service_type_val  .=$val .',' ;
                }


 	 $service_type=SUBSTR($service_type_val,0,-1);
//            $service_type = $this->input->post('service_type');

       //     $operation_area = $this->input->post('operation_area');

              foreach($this->input->post('operation_area') as $key =>$val){
                        $operation_area_val  .=$val .',' ;
                }


 	 $operation_area=SUBSTR($operation_area_val,0,-1);
*/
            $email = $this->input->post('email');
            $mobile = $this->input->post('mobile');
            $pass=$this->input->post('password');
            $ip=$this->input->ip_address();

        $formValues = array(
                'name' => $name,
                'spname' => $spname,
                'off_address' => $off_address,
                'area' => $area,
                'type' => $type,
                'landmark' => $landmark,
                'city' => $city,
                'state' => $state,
                'pincode' => $pincode,
                'country' => $country,
                'service_id' => $service_type,
                'operation_id' => $operation_area,
                'email' => $email,
                'mobile' => $mobile,
                'ip'=>$ip
            );


            //Load the model and add it to the Database

            if($this->signup_model->addProfileOffer($formValues)){

                $loginData = array(
                'name' => $name,
                'username' => $mobile,
                'pass' => $pass,
                'user_type'=>'2',
                'confirm'=>'1'
                );

                $emailData = array(
                'email' => $email,
                'username' => $mobile,
                'pass' => $pass,
                );

                $this->_sendSignupMailOffer($emailData);
                $this->_sendSignupMailAdmin($emailData);

                $login=$this->signup_model->addLogin($loginData);
                $msg = "<center><h1>Profile Added Successfully</h1></center>";


            }else{
                $msg = "<center><h1 style=\"color:red;\">Error Adding Candidate Profile</h1></center>";
            }
            $data['message'] = $msg;
            $data['data'] = NULL;
            $data['main_content'] = 'result_page';
            $this->load->view('includes/template', $data);

        }
    }


    /**
     * This checks the signup input and adds candidate to the database alongwith
     *  sending a signup mail.
     * 
     * @uses Signup::_sendSignupMail()
     * @uses Signup::addCandidate()
     * @author Amit Shrivastava
     * @package Vlab
     */

function _sendSignupMailOffer($val){
		$email=$val['username'];
                $email_send=$val['email'];
		$email=base64_encode($email);

        $username=$val['username'];
        $pass=$val['pass'];
        $msg = "
Hello,

We are excited to have you on board. Checkbox is an online  search,and booking platform for you, for all your home needs.


Your User Name: $username

Your Password:$pass

Checkbox Team.";

        $config['protocol']    = 'mail';
        $config['newline']    = "\r\n";
        $config['mailtype'] = 'text'; // or html
        $config['validation'] = TRUE; // bool whether to validate email or not

//        $config['protocol'] = 'smtp';
//        $config['charset'] = 'iso-8859-1';
        $config['wordwrap'] = FALSE;
//        $config['useragent'] = 'Probus';

        $this->load->library('email',$config);
        $this->email->from('admin@checkbox.com', 'Checkbox Signup Engine');
        $to = $email_send;
        $this->email->to($to);


        $this->email->subject('Activate your account on Checkbox');
        $this->email->message($msg);

        $this->email->send();

    }

function checkSignup() {
    
       $this->form_validation->set_rules('name', 'Name', 'trim|required|min_length[2]|max_length[25]|xss_clean');
       $this->form_validation->set_rules('email', 'Email Address', 'trim|required|valid_email|xss_clean');
       $this->form_validation->set_rules('mobile', 'Mobile Number', 'trim|min_length[10]|max_length[10]|required|numeric|xss_clean');
       $this->form_validation->set_rules('password', 'Password', 'trim|required|xss_clean|min_length[5]|max_length[32]|matches[passconf]|');
       $this->form_validation->set_rules('passconf', 'Password Confirmation', 'trim|required|md5');
       $this->form_validation->set_rules('area', 'Area', 'trim|required|xss_clean');
       $this->form_validation->set_rules('city', 'City', 'trim|required|xss_clean');
       $this->form_validation->set_rules('state', 'State', 'trim|required|xss_clean');
       $this->form_validation->set_rules('country', 'Country', 'trim|required|xss_clean');
       $this->form_validation->set_rules('pincode', 'Pincode', 'trim|min_length[6]|max_length[6]|required|numeric|xss_clean');
        
        //Run the validation rules and if false, show error messages on the view itself

        if($this->form_validation->run() == FALSE) {

        $this->index();
        }
        else{

            //Assign Posted Values to variables
           
            $name = $this->input->post('name');
            $lname = $this->input->post('lname');
            $email = $this->input->post('email');
            $mobile = $this->input->post('mobile');
            $flat_no = $this->input->post('flat_no');
            $society = $this->input->post('society');
            $street_add = $this->input->post('street_add');
            $area = $this->input->post('area');
            $landmark = $this->input->post('landmark');
            $city = $this->input->post('city');
            $state = $this->input->post('state');
            $pass=$this->input->post('password');
            $pincode = $this->input->post('pincode');
            $country = $this->input->post('country');
            $ip=$this->input->ip_address();
           
            $formValues = array(
                'name' => $name,
                'lname' => $lname,
                'username' => $mobile,
                'mobile' => $mobile,
                'flat_no' => $flat_no,
                'society' => $society,
                'street_add' => $street_add,
                'area' => $area,
                'landmark' => $landmark,
                'city' => $city,
                'state' => $state,
                'pincode' => $pincode,
                'country' => $country,
                'email' => $email,
                'ip'=>$ip
            );

        
            //Load the model and add it to the Database
                    
            if($this->signup_model->addProfile($formValues)){
               
                $loginData = array(
                'name' => $name,
                'username' => $mobile,
                'pass' => $pass,
                'user_type'=>'1',
                );

                $emailData = array(
                'email' => $email,
                'username' => $mobile,
                'pass' => $pass,
                );

                
                $login=$this->signup_model->addLogin($loginData);
                $this->_sendSignupMail($emailData);
                $this->_sendSignupMailAdmin($emailData);
                $msg = "<center><h1>Profile Added Successfully</h1></center>";
                $msg .= "<center><h4>Click on the approval link sent to your Inbox to activate your account.</h4></center>";

         
            }else{
                $msg = "<center><h1 style=\"color:red;\">Error Adding Candidate Profile</h1></center>";
            }
            $data['message'] = $msg;
            $data['data'] = NULL;
            $data['main_content'] = 'result_page';
            $this->load->view('includes/template', $data);
//            print_r($data);
        }
    }
 function ProfileHire()

    {
       $user=$this->session->userdata('user');
       $list= $this->login_model->Hire_profile($user);
       $data['list']=$list;
       $data['main_content'] = 'hire_profile_view';
       $this->load->view('includes/template', $data);
    }
    
function editSignup() {

       $this->form_validation->set_rules('name', 'Name', 'trim|required|min_length[2]|max_length[25]|xss_clean');
       $this->form_validation->set_rules('area', 'Area', 'trim|required|xss_clean');
       $this->form_validation->set_rules('city', 'City', 'trim|required|xss_clean');
       $this->form_validation->set_rules('state', 'State', 'trim|required|xss_clean');
       $this->form_validation->set_rules('country', 'Country', 'trim|required|xss_clean');
       $this->form_validation->set_rules('pincode', 'Pincode', 'trim|min_length[6]|max_length[6]|required|numeric|xss_clean');

        //Run the validation rules and if false, show error messages on the view itself

        if($this->form_validation->run() == FALSE) {

        $this->ProfileHire();
        }
        else{

            //Assign Posted Values to variables
            $hire_id= $this->input->post('hire_id');
            $name = $this->input->post('name');
            $lname = $this->input->post('lname');
            $flat_no = $this->input->post('flat_no');
            $society = $this->input->post('society');
            $street_add = $this->input->post('street_add');
            $area = $this->input->post('area');
            $landmark = $this->input->post('landmark');
            $city = $this->input->post('city');
            $state = $this->input->post('state');
            $pincode = $this->input->post('pincode');
            $country = $this->input->post('country');
            

            $formValues = array(
                'hire_id'=>$hire_id,
                'name' => $name,
                'lname' => $lname,
                'flat_no' => $flat_no,
                'society' => $society,
                'street_add' => $street_add,
                'area' => $area,
                'landmark' => $landmark,
                'city' => $city,
                'state' => $state,
                'pincode' => $pincode,
                'country' => $country,
                 'ip'=>$ip
            );


            //Load the model and add it to the Database

            if($this->signup_model->EditProfileHire($formValues)){
         
                $msg = "<center><h1>Profile Updated Successfully</h1></center>";

            }else{
                $msg = "<center><h1 style=\"color:red;\">Error Adding Candidate Profile</h1></center>";
            }
            $this->ProfileHire();
        }
    }

   function OfferProfile()

    {
       $user=$this->session->userdata('user');
       $list= $this->login_model->Offer_profile($user);
       $data['list']=$list;
       $data['main_content'] = 'offer_profile_view';
       $this->load->view('includes/template', $data);
    }

    function editOffer() {

       $this->form_validation->set_rules('spname', 'Service Provider Name', 'trim|required|min_length[2]|max_length[25]|xss_clean');
       $this->form_validation->set_rules('name', 'Name', 'trim|required|min_length[2]|max_length[25]|xss_clean');
       $this->form_validation->set_rules('city', 'City', 'trim|required|xss_clean');
       $this->form_validation->set_rules('state', 'State', 'trim|required|xss_clean');
       $this->form_validation->set_rules('country', 'Country', 'trim|required|xss_clean');
       $this->form_validation->set_rules('pincode', 'Pincode', 'trim|min_length[6]|max_length[6]|required|numeric|xss_clean');

        //Run the validation rules and if false, show error messages on the view itself

        if($this->form_validation->run() == FALSE) {

        $this->OfferProfile();
        }
        else{
        //Assign Posted Values to variables
            $offer_id=$this->input->post('offer_id');
            $name = $this->input->post('name');
            $spname = $this->input->post('spname');
            $off_address = $this->input->post('off_address');
            $area = $this->input->post('area');
            $type = $this->input->post('type');
            $landmark = $this->input->post('landmark');
            $city = $this->input->post('city');
            $state = $this->input->post('state');
            $pincode = $this->input->post('pincode');
            $country = $this->input->post('country');



        $formValues = array(
                'offer_id'=>$offer_id,
                'name' => $name,
                'spname' => $spname,
                'off_address' => $off_address,
                'area' => $area,
                'landmark' => $landmark,
                'city' => $city,
                'state' => $state,
                'pincode' => $pincode,
                'country' => $country,
               
            );


            //Load the model and add it to the Database

            if($this->signup_model->EditProfileOffer($formValues)){
                }else{
                $msg = "<center><h1 style=\"color:red;\">Error Adding Candidate Profile</h1></center>";
            }
            $this->OfferProfile();

        }
    }

    /**
     * Validates the Email Address for the signup_form_view AJAX call
     * 
     * @author Amit Shrivastava
     * @package Vlab
     * @uses Signup_Model::checkEmail($mail)
     * 
     */
        function validateEmail() {

        $this->form_validation->set_rules('email', 'Email Address', 'trim|required|valid_email|xss_clean');
        $this->form_validation->set_message('required', 'You need to enter an email address');
        $this->form_validation->set_message('valid_email', 'This does not look like a valid Email');
        $this->form_validation->set_error_delimiters('<div class="redAlert">','</div>');
        if($this->form_validation->run() == FALSE) {
            $data['message'] = $this->form_validation->error('email');
            $this->load->view('messages', $data);
        }else{
            $email = $this->input->post('email');
            $this->load->model('signup_model');
            $data['message'] = $this->signup_model->checkEmail($email);
            $this->load->view('messages', $data);
        }
    }

    /**
     * Sends out a mailer using the email library. The mailer sent has a link to activate
     * the account
     *
     * @param array $val
     * @author Amit Shrivastava
     * @package Vlab
     */

function _sendSignupMail($val){
		$email=$val['username'];
                $email_send=$val['email'];
		$email=base64_encode($email);
//        $link = base_url()."signup/confirm/".$email;
//        $links="http://www.amitshrivastava.co.cc/checkbox/";
        $username=$val['username'];
        $pass=$val['pass'];
        $msg = "
Hello,

We are excited to have you on board. Checkbox is an online  search,and booking platform for you, for all your home needs.

Now that you have successfully signed up with Checkbox, you need to activate your login. Click on the following link to activate your account:

amitshrivastava.co.cc/checkbox/signup/confirm/$email

Your User Name: $username

Your Password:$pass

Checkbox Team.";

        $config['protocol']    = 'mail';
        $config['newline']    = "\r\n";
        $config['mailtype'] = 'text'; // or html
        $config['validation'] = TRUE; // bool whether to validate email or not

//        $config['protocol'] = 'smtp';
//        $config['charset'] = 'iso-8859-1';
        $config['wordwrap'] = FALSE;
//        $config['useragent'] = 'Probus';

        $this->load->library('email',$config);
        $this->email->from('admin@checkbox.com', 'Checkbox Signup Engine');
        $to = $email_send;
        $this->email->to($to);


        $this->email->subject('Activate your account on Checkbox');
        $this->email->message($msg);

        $this->email->send();

    }

function _sendSignupMailAdmin($val){
		$email=$val['username'];
                $email_send=$val['email'];
		$email=base64_encode($email);

        $username=$val['username'];
        $pass=$val['pass'];
        $msg = "
Hello,


Your User Name: $username

Your Password:$pass

Checkbox Team.";

        $config['protocol']    = 'mail';
        $config['newline']    = "\r\n";
        $config['mailtype'] = 'text'; // or html
        $config['validation'] = TRUE; // bool whether to validate email or not

//        $config['protocol'] = 'smtp';
//        $config['charset'] = 'iso-8859-1';
        $config['wordwrap'] = FALSE;
//        $config['useragent'] = 'Probus';

        $this->load->library('email',$config);
        $this->email->from('admin@checkbox.com', 'Checkbox Signup Engine');
        $to = "shrivaamit@gmail.com";
        $this->email->to($to);


        $this->email->subject('New Account on Checkbox');
        $this->email->message($msg);

        $this->email->send();

    }




    /**
     * This funciton contrls the link that is sent in an emial to activate the
     * account. the link gets the user to this function. the funciton, marks the
     * user as active in the DB and displays a message.
     *
     * @param string $user
     * @author Amit Shrivastava
     * @package Vlab
     */
    function confirm($user){
      
      //  $user=base64_decode($user);
        $c = $this->signup_model->confirmCand($user);
        if($c){
            $msg = "<center><h1>Account Activated</h1></center>";
            $msg .= "<center><h4>Your account is active now. You may <a href=\"".base_url()."login\">Login</a> and start using the Checkbox.</h4></center>";
            $data['message'] = $msg;
            $data['data'] = NULL;
            $data['main_content'] = 'result_page';
            $this->load->view('includes/template', $data);
        }else{
            $msg = "<center><h1 style=\"color:red;\">Link Inactive</h1></center>";
            $msg .= "<center><h4>You have followed an inactive link. Please contact the administrator on admin[at]Checkbox.com</h4></center>";
            $data['message'] = $msg;
            $data['data'] = NULL;
            $data['main_content'] = 'result_page';
            $this->load->view('includes/template', $data);
        }
    }

 /**
     * Validates the Username for the AJAX call from signup_form_view. This checks
     * the username form a database using the signup_model MODEL and returns
     * a string with the status.
     *
     * @author : Amit
     * @package Checkbox
     *
     */
    function validateUsername() {
        $this->form_validation->set_rules('mobile','Mobile Number','trim|min_length[10]|max_length[10]|required|numeric|xss_clean');
       
        $this->form_validation->set_error_delimiters('<td><div class="redAlert"><img src="'.base_url().'images/invalide_icon.gif" width="23" height="23" align="absmiddle" />','</div></td>');
        if($this->form_validation->run() == FALSE){
            $data['message'] = $this->form_validation->error('mobile');
            $this->load->view('messages', $data);
        }else{
            $usrname = $this->input->post('mobile');
            $this->load->model('signup_model');
            $data['message'] = $this->signup_model->checkUsername($usrname);
            $this->load->view('messages', $data);
        }
    }

}

?>
